#include <sys/types.h>
#include <dirent.h>
#include <errno.h>
#include <vector>
#include <string>
#include <map>
#include <iostream>
#include <sstream>
#include <stdio.h>
#include <stdlib.h>

using namespace std;

/*function...*/
int getdir (string dir, vector<string> &files)
{
    DIR *dp;
    struct dirent *dirp;
    if((dp  = opendir(dir.c_str())) == NULL) {
        cout << "Error(" << errno << ") opening " << dir << endl;
        return errno;
    }

    while ((dirp = readdir(dp)) != NULL) {
        files.push_back(string(dirp->d_name));
    }
    closedir(dp);
    return 0;
}


int main()
{
  /* List of country codes */
std::map<std::string, std::string> countries;
countries["af"] = "Afghanistan";
countries["ax"] = "Aland Islands";
countries["al"] = "Albania";
countries["dz"] = "Algeria";
countries["as"] = "American Samoa";
countries["ad"] = "Andorra";
countries["ao"] = "Angola";
countries["ai"] = "Anguilla";
countries["aq"] = "Antarctica";
countries["ag"] = "Antigua And Barbuda";
countries["ar"] = "Argentina";
countries["am"] = "Armenia";
countries["aw"] = "Aruba";
countries["au"] = "Australia";
countries["at"] = "Austria";
countries["az"] = "Azerbaijan";
countries["bs"] = "Bahamas";
countries["bh"] = "Bahrain";
countries["bd"] = "Bangladesh";
countries["bb"] = "Barbados";
countries["by"] = "Belarus";
countries["be"] = "Belgium";
countries["bz"] = "Belize";
countries["bj"] = "Benin";
countries["bm"] = "Bermuda";
countries["bt"] = "Bhutan";
countries["bo"] = "Bolivia";
countries["ba"] = "Bosnia And Herzegovina";
countries["bw"] = "Botswana";
countries["bv"] = "Bouvet Island";
countries["br"] = "Brazil";
countries["io"] = "British Indian Ocean Territory";
countries["bn"] = "Brunei Darussalam";
countries["bg"] = "Bulgaria";
countries["bf"] = "Burkina Faso";
countries["bi"] = "Burundi";
countries["kh"] = "Bambodia";
countries["cm"] = "Bameroon";
countries["ca"] = "Canada";
countries["cv"] = "Cape Verde";
countries["ky"] = "Cayman Islands";
countries["cf"] = "Central African Republic";
countries["td"] = "Chad";
countries["cl"] = "Chile";
countries["cn"] = "China";
countries["cx"] = "Christmas Island";
countries["cc"] = "Cocos (keeling) Islands";
countries["co"] = "Colombia";
countries["km"] = "Comoros";
countries["cg"] = "Congo";
countries["cd"] = "Congo, Democratic Republic";
countries["ck"] = "Cook Islands";
countries["cr"] = "Costa Rica";
countries["ci"] = "Cote d\"ivoire";
countries["hr"] = "Croatia";
countries["cu"] = "Cuba";
countries["cy"] = "Cyprus";
countries["cz"] = "Czech Republic";
countries["dk"] = "Denmark";
countries["dj"] = "Djibouti";
countries["dm"] = "Dominica";
countries["do"] = "Dominican Republic";
countries["ec"] = "Ecuador";
countries["eg"] = "Egypt";
countries["sv"] = "El Salvador";
countries["gq"] = "Equatorial Guinea";
countries["er"] = "Eritrea";
countries["ee"] = "Estonia";
countries["et"] = "Ethiopia";
countries["fk"] = "Falkland Islands (malvinas)";
countries["fo"] = "Faroe Islands";
countries["fj"] = "Fiji";
countries["fi"] = "Finland";
countries["fr"] = "France";
countries["gf"] = "French Guiana";
countries["pf"] = "French Polynesia";
countries["tf"] = "French Southern Territories";
countries["ga"] = "Gabon";
countries["gm"] = "Gambia";
countries["ge"] = "Georgia";
countries["de"] = "Germany";
countries["gh"] = "Ghana";
countries["gi"] = "Gibraltar";
countries["gr"] = "Greece";
countries["gl"] = "Greenland";
countries["gd"] = "Grenada";
countries["gp"] = "Guadeloupe";
countries["gu"] = "Guam";
countries["gt"] = "Guatemala";
countries["gg"] = "Guernsey";
countries["gn"] = "Guinea";
countries["gw"] = "Guinea-bissau";
countries["gy"] = "Guyana";
countries["ht"] = "Haiti";
countries["hm"] = "Heard Island & Mcdonald Islands";
countries["va"] = "Holy See (Vatican City State)";
countries["hn"] = "Honduras";
countries["hk"] = "Hong Kong";
countries["hu"] = "Hungary";
countries["is"] = "Iceland";
countries["in"] = "India";
countries["id"] = "Indonesia";
countries["ir"] = "Iran, Islamic Republic Of";
countries["iq"] = "Iraq";
countries["ie"] = "Ireland";
countries["im"] = "Isle Of Man";
countries["il"] = "Israel";
countries["it"] = "Italy";
countries["jm"] = "Jamaica";
countries["jp"] = "Japan";
countries["je"] = "Jersey";
countries["jo"] = "Jordan";
countries["kz"] = "Kazakhstan";
countries["ke"] = "Kenya";
countries["ki"] = "Kiribati";
countries["kr"] = "Korea";
countries["kw"] = "Kuwait";
countries["kg"] = "Kyrgyzstan";
countries["la"] = "Lao People\"s Democratic Republic";
countries["lv"] = "Latvia";
countries["lb"] = "Lebanon";
countries["ls"] = "Lesotho";
countries["lr"] = "Liberia";
countries["ly"] = "Libyan Arab Jamahiriya";
countries["li"] = "Liechtenstein";
countries["lt"] = "Lithuania";
countries["lu"] = "Luxembourg";
countries["mo"] = "Macao";
countries["mk"] = "Macedonia";
countries["mg"] = "Madagascar";
countries["mw"] = "Malawi";
countries["my"] = "Malaysia";
countries["mv"] = "Maldives";
countries["ml"] = "Mali";
countries["mt"] = "Malta";
countries["mh"] = "Marshall Islands";
countries["mq"] = "Martinique";
countries["mr"] = "Mauritania";
countries["mu"] = "Mauritius";
countries["yt"] = "Mayotte";
countries["mx"] = "Mexico";
countries["fm"] = "Micronesia, Federated States Of";
countries["md"] = "Moldova";
countries["mc"] = "Monaco";
countries["mn"] = "Mongolia";
countries["me"] = "Montenegro";
countries["ms"] = "Montserrat";
countries["ma"] = "Morocco";
countries["mz"] = "Mozambique";
countries["mm"] = "Myanmar";
countries["na"] = "Namibia";
countries["nr"] = "Nauru";
countries["np"] = "Nepal";
countries["nl"] = "Netherlands";
countries["an"] = "Netherlands Antilles";
countries["nc"] = "New Caledonia";
countries["nz"] = "New Zealand";
countries["ni"] = "Nicaragua";
countries["ne"] = "Niger";
countries["ng"] = "Nigeria";
countries["nu"] = "Niue";
countries["nf"] = "Norfolk Island";
countries["mp"] = "Northern Mariana Islands";
countries["no"] = "Norway";
countries["om"] = "Oman";
countries["pk"] = "Pakistan";
countries["pw"] = "Palau";
countries["ps"] = "Palestinian Territory, Occupied";
countries["pa"] = "Panama";
countries["pg"] = "Papua New Guinea";
countries["py"] = "Paraguay";
countries["pe"] = "Peru";
countries["ph"] = "Philippines";
countries["pn"] = "Pitcairn";
countries["pl"] = "Poland";
countries["pt"] = "Portugal";
countries["pr"] = "Puerto Rico";
countries["qa"] = "Qatar";
countries["re"] = "Reunion";
countries["ro"] = "Romania";
countries["ru"] = "Russian Federation";
countries["rw"] = "Rwanda";
countries["bl"] = "Saint Barthelemy";
countries["sh"] = "Saint Helena";
countries["kn"] = "Saint Kitts And Nevis";
countries["lc"] = "Saint Lucia";
countries["mf"] = "Saint Martin";
countries["pm"] = "Saint Pierre And Miquelon";
countries["vc"] = "Saint Vincent And Grenadines";
countries["ws"] = "Samoa";
countries["sm"] = "San Marino";
countries["st"] = "Sao Tome And Principe";
countries["sa"] = "Saudi Arabia";
countries["sn"] = "Senegal";
countries["rs"] = "Serbia";
countries["sc"] = "Seychelles";
countries["sl"] = "Sierra Leone";
countries["sg"] = "Singapore";
countries["sk"] = "Slovakia";
countries["si"] = "Slovenia";
countries["sb"] = "Solomon Islands";
countries["so"] = "Somalia";
countries["za"] = "South Africa";
countries["gs"] = "South Georgia And Sandwich Isl.";
countries["es"] = "Spain";
countries["lk"] = "Sri Lanka";
countries["sd"] = "Sudan";
countries["sr"] = "Suriname";
countries["sj"] = "Svalbard And Jan Mayen";
countries["sz"] = "Swaziland";
countries["se"] = "Sweden";
countries["ch"] = "Switzerland";
countries["sy"] = "Syrian Arab Republic";
countries["tw"] = "Taiwan";
countries["tj"] = "Tajikistan";
countries["tz"] = "Tanzania";
countries["th"] = "Thailand";
countries["tl"] = "Timor-leste";
countries["tg"] = "Togo";
countries["tk"] = "Tokelau";
countries["to"] = "Tonga";
countries["tt"] = "Trinidad And Tobago";
countries["tn"] = "Tunisia";
countries["tr"] = "Turkey";
countries["tm"] = "Turkmenistan";
countries["tc"] = "Turks And Caicos Islands";
countries["tv"] = "Tuvalu";
countries["ug"] = "Uganda";
countries["ua"] = "Ukraine";
countries["ae"] = "United Arab Emirates";
countries["uk"] = "United Kingdom"; /* Corrected from "gb" to "uk" */
countries["us"] = "United States";
countries["um"] = "United States Outlying Islands";
countries["uy"] = "Uruguay";
countries["uz"] = "Uzbekistan";
countries["vu"] = "Vanuatu";
countries["ve"] = "Venezuela";
countries["vn"] = "Viet Nam";
countries["vg"] = "Virgin Islands, British";
countries["vi"] = "Virgin Islands, U.S.";
countries["wf"] = "Wallis And Futuna";
countries["eh"] = "Western Sahara";
countries["ye"] = "Yemen";
countries["zm"] = "Zambia";
countries["zw"] = "Zimbabwe";


    /* Useful Variables */
    unsigned int input = 0;

    /* Getting the config files */
    string dir = string("/etc/openvpn");
    vector<string> files = vector<string>();

    getdir(dir,files);

    for (unsigned int i = 0;i < files.size();i++) {

        std::string country = files[i].substr (0,2);

        cout << "\e[0m" << i << ":\e[0m\e[4m" << files[i] << "\e[0m — \e[1m" << countries[country] << endl;
    }
    // How to get a string/sentence with spaces
    cout << "Type the number of the server to connect to:\n>";
    cin >> input;

    cout << "Attempting to connect to: " << input << " \e[4m" << files[input] << "\e[0m " << endl << endl;
    system(("sudo openvpn /etc/openvpn/"+ files[input]+"; exec bash").c_str());

    return 0;
}








